(* ----------------------------------------------------------------------- *)
          (*------------------- smlnaivebayes -----------------*)
(* ----------------------------------------------------------------------- *)

(* Modul 1, Dan, Jackie og Arne *)
(*Tokenizer*)
(* Tager en fil og giver en string list *)

(* ----------------------------------------------------------------------- *)
load"String";
load"TextIO";
load"Char";
load"Real";
load"Int";
load"Substring";

type token = {ts: string, s: real, n: real};
type tokenList = token list;
type listA = string list;

val DBfile = "lsb.dbx";

(* Tokenizer*)
(* Tager hele fileIn og bryder den op i tokens, defineret af Char.isSpace alts hvor der er mellemrum*)

fun eradicateDub(s,[]:string list) = []
  | eradicateDub(s,x::l:string list) = if s = x then eradicateDub(s,l) else x::eradicateDub(s,l):string list;
 
fun check4dub ([]:string list) = []
  | check4dub (x::l) = 
    let 
	val newlist = eradicateDub(x,l)
    in 
	x::check4dub(newlist)
    end;

fun iMtt(fileIn) =

    let
	val file = TextIO.openIn fileIn
	val s = TextIO.inputAll file
    in
	check4dub(String.tokens Char.isSpace s)                   
    end

(* ----------------------------------------------------------------------- *)
(* Modul 2 *)
(* ----------------------------------------------------------------------- *)


(* 
listA = listen af "ord" som vi faar fra mailen
ts = tokenstring, den string som er fundet i forgaaende mails ex."fisk" 
s = antal gange fundet i spam mail				 
n = antal gange fundet i no spam mail *)


exception FileError;

fun TokenRecordBuilder [s,x,y] =
      {ts = s, s = valOf (Real.fromString x), n = valOf (Real.fromString y)}
  | TokenRecordBuilder _ = raise FileError;


fun ReadLine file =
      let        
        val line = TextIO.inputLine file
        val lineList = String.tokens Char.isSpace (line)
  
      in 
        TokenRecordBuilder lineList
      end;


fun ReadFile file =
      if TextIO.endOfStream file
      then (TextIO.closeIn file; [])
      else (ReadLine file)::(ReadFile file);


fun DataBase (file) = ReadFile(TextIO.openIn file);


fun findTokenP (_, []: tokenList) = 0.4
  | findTokenP (t, {ts,s,n}::tList) = 
    
    if t=ts then s/(n+s)
    else findTokenP(t, tList);

fun Plist ([],db:tokenList) = []
  | Plist (s::lA,db) = findTokenP(s,db)::Plist(lA,db);

fun STPlist (stringlist)= 
    let
	val db = DataBase(DBfile)
    in
	Plist(stringlist,db)
    end;


(* ---------------------------------------------------------------------- *)
(* Modul 3 *)
(* ---------------------------------------------------------------------- *)

(*Udregninger af samlet produkt, samlet konjugeret produkt og samlet betinget sandsynlighed vha Paul Grahams formel*)

fun sA [] = 1.0
| sA (x::l) = x * sA(l);

fun sB [] = 1.0
| sB (x::l) = (1.0-x)*sB(l);

fun ss (listIn) = sA(listIn)/(sA(listIn)+sB(listIn));

(* ---------------------------------------------------------------------- *)
(* Modul 4 *)
(* ---------------------------------------------------------------------- *)
(* bner spamrate og lser den frste linie som Real fra String*)

fun readspamRate() =
    let 
	val file = TextIO.openIn "spamrate.txt"
	val n = TextIO.inputLine file
    in 
	valOf(Real.fromString n) 
    end;

(* Sammenligner samletsandsynliged med input fra spamrate og giver et output om det er en spam*)

(* ---------------------------------------------------------------------- *)

(* dette modul srger for at updatere databasen (ikke frdig endnu)    *)


fun updateToken  (spam,nospam,t, []: tokenList) = [{ts=t,s=2.0,n=3.0}]
  | updateToken (spam,nospam,t, {ts,s,n}::tList) = 
    
    if t=ts then {ts=ts, s=s+spam,n=n+nospam}::tList       
    else {ts=ts,s=s,n=n}::updateToken(spam,nospam,t, tList);

fun DBupdate (spam,nospam,[],db )= db
  | DBupdate (spam,nospam,x::l,db) = 
    let
	val temp = updateToken(spam,nospam,x,db)
    in
	DBupdate(spam,nospam,l,temp)
    end;

    
fun writeToStream ([],stream) = stream
  | writeToStream (x::l,stream) = 
    let
	val newstream = stream
    in
	TextIO.output(newstream,x);
	TextIO.output(newstream,"\n");
	writeToStream(l,newstream)
    end

fun ush ([]:tokenList) = []
  | ush ({ts,s,n}::tList) = String.concat([ts," ",Real.toString(s)," ",Real.toString(n)])::ush(tList);

fun writeToDisk (tList,file) =
    let
	val opf = TextIO.openOut(file)
	val stringlist = ush(tList)
    in
	TextIO.flushOut(writeToStream(stringlist,opf))
    end;



(* ---------------------------------------------------------------------- *)
(* Modul 6 *)

(* ---------------------------------------------------------------------- *)
(* Brugeropstning af spamvrdi i spamrate.txt *)
(* ---------------------------------------------------------------------- *)
(* bner TextIO*)
(* Outputter tekst til brugeren, bner spamrate.txt, Inputter de 4 frste inputs og skriver til spamrate.txt*)

open TextIO;
fun inputspamvalue (fileOut)=
    let 
	val definer =
	    (output(stdOut,"Definer din spam graense i intervallet [0;1] med 2 decimaler\n ");    
	    flushOut(stdOut));
	val os = openOut fileOut
	val sv = inputN(stdIn, 4 );
in
	output (os, sv);
	flushOut(os)
end;

(* ---------------------------------------------------------------------- *)
(* Made by Group A325 2002 at University of Aalborg, Denmark, Look but dont touch*)
(* Members of A325 are Jens Peter Bak, Dan Malthesen, Bjarne M. Kondrup, Lars Ole Christensen, Jaqulin Khuganaikabahu and Arne Mejlholm *)
(* So far we reserve all rights in this code *)


(* Addition Bayesian way of calculating the spam probability *)


fun getNoSPAM() =
    let 
	val file = TextIO.openIn "spam.no"
	val n = TextIO.inputLine file
    in 
	valOf(Real.fromString n)
    end;

fun getNoMAIL() =
    let 
	val file = TextIO.openIn "mail.no"
	val n = TextIO.inputLine file
    in 
	valOf(Real.fromString n)
    end;

fun addNoMail() =
    let
        val r = getNoMAIL()+1.0;
	val opf = TextIO.openOut("mail.no");
        val s = Real.toString(r);
	
    in
	TextIO.output(opf, s);
	TextIO.flushOut(opf)
    end;

fun addNoSpam() =
    let
        val r = getNoMAIL()+1.0;
	val opf = TextIO.openOut("spam.no");
        val s = Real.toString(r);
	
    in
	TextIO.output(opf, s);
	TextIO.flushOut(opf)
    end;

fun pC(mail) = getNoSPAM()/getNoMAIL();


fun pAmail(x,[]) = 1.0
  | pAmail(x,{ts,s,n}::l) = ((s+n)/x) * pAmail(x,l);

fun pAdb(x,[]) = 1.0
  | pAdb(x,{ts,s,n}::l) = ((x-(s+n))/x) * pAdb(x,l);

fun pACmail(x,[]) = 1.0
  | pACmail(x,{ts,s,n}::l) = (s/x) * pACmail(x,l);

fun pACdb(x,[]) = 1.0
  | pACdb(x,{ts,s,n}::l) = ((x-s)/x) * pACdb(x,l);


fun PCA(listS:tokenList,listDB:tokenList) =
    let
        val ns = getNoSPAM();
        val nm = getNoMAIL();
    in 
        ((pACmail(ns,listS)*pACdb(ns,listDB))/(pAmail(nm,listS)*pAdb(nm,listDB)))*pC("ostepops")
    end;
    

fun findT1 (_, []: tokenList) = []
  | findT1 (t, {ts,s,n}::tList) = 
    
    if t=ts then {ts = ts, s = s, n = n}::[]
    else findT1(t, tList);


fun findMTlist ([],db:tokenList) = []
  | findMTlist  (s::lA,db) = findT1(s,db)::findMTlist(lA,db);

fun findTok (_, []: tokenList) = []
  | findTok (t, {ts,s,n}::tList) = 
    
    if t=ts then tList
    else {ts = ts ,s = s ,n =n}::findTok(t, tList);


fun findDBTlist ([],db:tokenList) = db
  | findDBTlist  (s::lA,db) = 
    let
	val dbNew = findTok(s,db)
    in
	findDBTlist(lA,dbNew)
    end;


fun PBayes(mail) =
    let
        val sList = iMtt(mail);
        val listALL = DataBase(DBfile);
        val listS = List.concat(findMTlist(sList,listALL));
        val listDB = findDBTlist(sList,listALL);
    in
      PCA(listS,listDB)
    end; 

(* ---------------------------------------------------------------------- *)
(* Modul 7 *)
(* ---------------------------------------------------------------------- *)

fun addSpam(mailFile) =
    let
	val mail = iMtt(mailFile)
	val db = DataBase(DBfile)
    in
	writeToDisk(DBupdate (1.0,0.0,mail,db),DBfile);
	addNoSpam();
	addNoMail()
    end

(* ---------------------------------------------------------------------- *)
(* Modul 8 *)
(* ---------------------------------------------------------------------- *)

fun addHam(mailFile) =
    let
	val mail = iMtt(mailFile)
	val db = DataBase(DBfile)
    in
	writeToDisk(DBupdate (0.0,1.0,mail,db),DBfile);
	addNoMail()
    end

(*--------------------------------------------------------------------*)
fun Yes(s,file) =
    let
    in
	print s
	(*addSpam(file)*)
    end;

fun No(s,file) =
    let
    in
	print s
	(*addHam(file)*)
    end;

fun spaM(filename) = 
    let
	val grahamP = ss(STPlist(iMtt(filename)));
	val bayersP = PBayes(filename);
	val sbPno = concat(["Det er nok ikke en spam mail i flge Bayers\n Bayes sandsynlighed: ", Real.toString(bayersP),"\n Grahams sandsynlighed: ",Real.toString(grahamP),"\n"]);
	val sbPyes = concat(["Det er nok en spam mail i flge Bayers\n Bayes sandsynlighed: ", Real.toString(bayersP),"\n Grahams sandsynlighed: ",Real.toString(grahamP),"\n"]);
    in
	if bayersP < readspamRate() 
	then
	Yes(sbPno,filename)
	else 
	No(sbPyes,filename)
    end;   


